local GroupAccept = {}
local LAM = LibStub("LibAddonMenu-1.0")

local savedVars

local defaults = {
	acceptByFriends = true,
	acceptByGuild = true
}

function GroupAccept:InviteReceived(event, inviterName)
	if IsPlayerInGroup("player") then return end
	if savedVars.acceptByGuild then
		for i = 1, GetNumGuildMembers() do
			local _, charName = GetGuildMemberCharacterInfo(i)
			if charName == inviterName then
				AcceptGroupAccept()
			end
			break
		end
	elseif savedVars.acceptByFriends then
		for i = 1, GetNumFriends() do
			local _, charName = GetFriendCharacterInfo(i)
			if charName == inviterName then
				AcceptGroupAccept()
			end
			break
		end
	end
end

function GroupAccept:AddOnLoaded(event, AddOn)
	if not AddOn == "GroupAccept" then return end
	
	savedVars = ZO_SavedVars:NewAccountWide("GroupAcceptDB", 1, nil, defaults)
	
	-- plug into the AddOns button
	local giPanel = LAM:CreateControlPanel("GroupAccept", "Group Accept")
	LAM:AddHeader(giPanel, "GroupAcceptHeader", "Group Accept")
	LAM:AddCheckbox(giPanel, "GroupAccept_Accept_Friends", "Accept Friends", "Automatically accept group invite requests from friends",
		function() return savedVars.acceptByFriends end, -- get function
		function() -- set function
			savedVars.acceptByFriends = not savedVars.acceptByFriends
	end)
	LAM:AddCheckbox(giPanel, "GroupAccept_Accept_Guild", "Accept Guild Members", "Automatically accept group invite requests from guild members",
		function() return savedVars.acceptByGuild end, -- get function
		function() -- set function
			savedVars.acceptByGuild = not savedVars.acceptByGuild
	end)
end

EVENT_MANAGER:RegisterForEvent("GroupAccept", EVENT_ADD_ON_LOADED, GroupAccept.AddOnLoaded)
EVENT_MANAGER:RegisterForEvent("GroupAccept", EVENT_GROUP_INVITE_RECEIVED, GroupAccept.InviteReceived)